commit 5deacc558cd8e4d94cc5a94c1cf83b91d077d4d3
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Thu May 9 13:46:47 2024 +0530

    PS-9174 Assertion Failure in /mysql-8.0.34/sql/field.cc:7119
    
    https://perconadev.atlassian.net/browse/PS-9174
    
    Bug#35846221 mysql/mysql-server@3cd7cd2066f
    
    Problem is due to missing implementation of
    Item_func_make_set::fix_after_pullout(), which makes this particular
    MAKE_SET function be regarded as const and may thus be evaluated
    during resolving.
    
    Fixed by implementing a proper fix_after_pullout() function.
    
    Change-Id: I7094869588ce4133c4a925e1a237a37866a5bb3c
    (cherry picked from commit a9f0b388adeef837811fdba2bce2e4ba5b06863b)

diff --git a/sql/item_strfunc.cc b/sql/item_strfunc.cc
index 2e020f0778b..653862c953c 100644
--- a/sql/item_strfunc.cc
+++ b/sql/item_strfunc.cc
@@ -3310,6 +3310,36 @@ void Item_func_make_set::fix_length_and_dec()
   with_sum_func= with_sum_func || item->with_sum_func;
 }
 
+bool Item_func_make_set::fix_fields(THD *thd, Item **ref) {
+  assert(!fixed);
+  if (!item->fixed && item->fix_fields(thd, &item)) {
+    return true;
+  }
+  if (item->check_cols(1)) {
+    return true;
+  }
+  if (Item_func::fix_fields(thd, ref)) {
+    return true;
+  }
+  if (item->maybe_null) {
+    maybe_null = true;
+  }
+
+  used_tables_cache|=     item->used_tables();
+  not_null_tables_cache|= item->not_null_tables();
+  const_item_cache&=      item->const_item();
+
+  return false;
+}
+
+void Item_func_make_set::fix_after_pullout(st_select_lex *parent_select,
+                                           st_select_lex *removed_select) {
+  Item_func::fix_after_pullout(parent_select, removed_select);
+  item->fix_after_pullout(parent_select, removed_select);
+  used_tables_cache|=     item->used_tables();
+  not_null_tables_cache|= item->not_null_tables();
+  const_item_cache&=      item->const_item();
+}
 
 void Item_func_make_set::update_used_tables()
 {
diff --git a/sql/item_strfunc.h b/sql/item_strfunc.h
index 5cd0c9eaa34..d0342d3a7fb 100644
--- a/sql/item_strfunc.h
+++ b/sql/item_strfunc.h
@@ -834,15 +834,9 @@ public:
 
   virtual bool itemize(Parse_context *pc, Item **res);
   String *val_str(String *str);
-  bool fix_fields(THD *thd, Item **ref)
-  {
-    assert(fixed == 0);
-    bool res= ((!item->fixed && item->fix_fields(thd, &item)) ||
-               item->check_cols(1) ||
-               Item_func::fix_fields(thd, ref));
-    maybe_null|= item->maybe_null;
-    return res;
-  }
+  bool fix_fields(THD *thd, Item **ref);
+  void fix_after_pullout(st_select_lex *parent_select,
+                         st_select_lex *removed_select);
   void split_sum_func(THD *thd, Ref_ptr_array ref_pointer_array,
                       List<Item> &fields);
   void fix_length_and_dec();

